package com.smartchoice.productproceser.config;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.core.QueueBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import com.smartchoice.common.model.rabbitmq.ExchangeName;
import com.smartchoice.common.model.rabbitmq.QueueName;

@Component
public class RabbitMQProvision {

    private static Logger log = LogManager.getLogger(RabbitMQProvision.class);

    public static final int TTL = 300000;

    //////////////////////////////////////////////////////TIKI STARTS//////////////////////////////////////////////////////

    //TIKI START DEFINING QUEUES
    @Bean
    Queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN() {
        log.info("Creating queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN");
        return QueueBuilder.durable(QueueName.TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN)
                .deadLetterExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING)
                .deadLetterRoutingKey(QueueName.TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY() {
        log.info("Creating queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY");
        return QueueBuilder.durable(QueueName.TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY)
                .deadLetterExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN)
                .deadLetterRoutingKey(QueueName.TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING() {
        log.info("Creating queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING");
        return new Queue(QueueName.TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING, true);
    }

    @Bean
    Queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN() {
        log.info("Creating queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN");
        return QueueBuilder.durable(QueueName.TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN)
                .deadLetterExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING)
                .deadLetterRoutingKey(QueueName.TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY() {
        log.info("Creating queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY");
        return QueueBuilder.durable(QueueName.TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY)
                .deadLetterExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN)
                .deadLetterRoutingKey(QueueName.TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING() {
        log.info("Creating queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING");
        return new Queue(QueueName.TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING, true);
    }


    //TIKI START DEFINING EXCHANGES

    @Bean
    DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN() {
        log.info("Creating exchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN");
        return new DirectExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN);
    }

    @Bean
    DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY() {
        log.info("Creating exchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY");
        return new DirectExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY);
    }

    @Bean
    DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING() {
        log.info("Creating exchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING");
        return new DirectExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING);
    }

    @Bean
    DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN() {
        log.info("Creating exchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN");
        return new DirectExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN);
    }

    @Bean
    DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY() {
        log.info("Creating exchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY");
        return new DirectExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY);
    }

    @Bean
    DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING() {
        log.info("Creating exchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING");
        return new DirectExchange(ExchangeName.TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING);
    }

    //TIKI START BIDING

    @Bean
    Binding TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN_BIDING(Queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN, DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN) {
        log.info("Binding queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN to TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN");
        return BindingBuilder.bind(TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN)
                .to(TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN)
                .with(QueueName.TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN);
    }

    @Bean
    Binding TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY_BIDING(Queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY, DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY) {
        log.info("Binding queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY to TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY");
        return BindingBuilder.bind(TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY).to(TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY).with(QueueName.TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY);
    }

    @Bean
    Binding TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING_BIDING(Queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING, DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING) {
        log.info("Binding queue TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING to TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING");
        return BindingBuilder.bind(TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING).to(TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING).with(QueueName.TIKI_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING);
    }

    @Bean
    Binding TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN_BIDING(Queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN, DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN) {
        log.info("Binding queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN to TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN");
        return BindingBuilder.bind(TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN).to(TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN).with(QueueName.TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN);
    }

    @Bean
    Binding TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY_BIDING(Queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY, DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY) {
        log.info("Binding queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY to TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY");
        return BindingBuilder.bind(TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY).to(TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY).with(QueueName.TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY);
    }


    @Bean
    Binding TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING_BIDING(Queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING, DirectExchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING) {
        log.info("Binding queue TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING to TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING");
        return BindingBuilder.bind(TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING).to(TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING).with(QueueName.TIKI_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING);
    }

    //////////////////////////////////////////////////////TIKI ENDS//////////////////////////////////////////////////////


    //////////////////////////////////////////////////////SENDO STARTS//////////////////////////////////////////////////////

    //SENDO START DEFINING QUEUES
    @Bean
    Queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN() {
        log.info("Creating queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN");
        return QueueBuilder.durable(QueueName.SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN)
                .deadLetterExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING)
                .deadLetterRoutingKey(QueueName.SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY() {
        log.info("Creating queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY");
        return QueueBuilder.durable(QueueName.SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY)
                .deadLetterExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN)
                .deadLetterRoutingKey(QueueName.SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING() {
        log.info("Creating queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING");
        return new Queue(QueueName.SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING, true);
    }


    @Bean
    Queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN() {
        log.info("Creating queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN");
        return QueueBuilder.durable(QueueName.SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN)
                .deadLetterExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING)
                .deadLetterRoutingKey(QueueName.SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY() {
        log.info("Creating queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY");
        return QueueBuilder.durable(QueueName.SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY)
                .deadLetterExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN)
                .deadLetterRoutingKey(QueueName.SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING() {
        log.info("Creating queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING");
        return new Queue(QueueName.SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING, true);
    }

    //SENDO START DEFINING EXCHANGES

    @Bean
    DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN() {
        log.info("Creating exchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN");
        return new DirectExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN);
    }

    @Bean
    DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY() {
        log.info("Creating exchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY");
        return new DirectExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY);
    }

    @Bean
    DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING() {
        log.info("Creating exchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING");
        return new DirectExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING);
    }

    @Bean
    DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN() {
        log.info("Creating exchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN");
        return new DirectExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN);
    }

    @Bean
    DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY() {
        log.info("Creating exchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY");
        return new DirectExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY);
    }

    @Bean
    DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING() {
        log.info("Creating exchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING");
        return new DirectExchange(ExchangeName.SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING);
    }

    //SENDO START BIDING

    @Bean
    Binding SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN_BIDING(Queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN, DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN) {
        log.info("Binding queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN to SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN");
        return BindingBuilder.bind(SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN).to(SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_MAIN).with(QueueName.SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_MAIN);
    }

    @Bean
    Binding SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY_BIDING(Queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY, DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY) {
        log.info("Binding queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY to SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY");
        return BindingBuilder.bind(SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY).to(SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_RETRY).with(QueueName.SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_RETRY);
    }


    @Bean
    Binding SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING_BIDING(Queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING, DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING) {
        log.info("Binding queue SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING to SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING");
        return BindingBuilder.bind(SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING).to(SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_REQUEST_PARKING).with(QueueName.SENDO_RABBITMQ_QUEUE_NAME_CATEGORY_REQUEST_PARKING);
    }

    @Bean
    Binding SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN_BIDING(Queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN, DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN) {
        log.info("Binding queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN to SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN");
        return BindingBuilder.bind(SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN).to(SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_MAIN).with(QueueName.SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_MAIN);
    }

    @Bean
    Binding SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY_BIDING(Queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY, DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY) {
        log.info("Binding queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY to SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY");
        return BindingBuilder.bind(SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY).to(SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_RETRY).with(QueueName.SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_RETRY);
    }

    @Bean
    Binding SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING_BIDING(Queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING, DirectExchange SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING) {
        log.info("Binding queue SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING to SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING");
        return BindingBuilder.bind(SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING).to(SENDO_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_REQUEST_PARKING).with(QueueName.SENDO_RABBITMQ_QUEUE_NAME_PRODUCT_REQUEST_PARKING);
    }

    //////////////////////////////////////////////////////SENDO ENDS//////////////////////////////////////////////////////

    //////////////////////////////////////////////////////SC STARTS//////////////////////////////////////////////////////

    //TIKI START DEFINING QUEUES
    @Bean
    Queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN() {
        log.info("Creating queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN");
        return QueueBuilder.durable(QueueName.SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN)
                .deadLetterExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_PARKING)
                .deadLetterRoutingKey(QueueName.SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_RETRY() {
        log.info("Creating queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_RETRY");
        return QueueBuilder.durable(QueueName.SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_RETRY)
                .deadLetterExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_MAIN)
                .deadLetterRoutingKey(QueueName.SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING() {
        log.info("Creating queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING");
        return new Queue(QueueName.SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING, true);
    }

    @Bean
    Queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN() {
        log.info("Creating queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN");
        return QueueBuilder.durable(QueueName.SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN)
                .deadLetterExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_PARKING)
                .deadLetterRoutingKey(QueueName.SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_RETRY() {
        log.info("Creating queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_RETRY");
        return QueueBuilder.durable(QueueName.SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_RETRY)
                .deadLetterExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_MAIN)
                .deadLetterRoutingKey(QueueName.SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN)
                .ttl(TTL)
                .build();
    }

    @Bean
    Queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING() {
        log.info("Creating queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING");
        return new Queue(QueueName.SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING, true);
    }

    //SC START DEFINING EXCHANGES
    @Bean
    DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_MAIN() {
        log.info("Creating exchange TIKI_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_MAIN");
        return new DirectExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_MAIN);
    }

    @Bean
    DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_RETRY() {
        log.info("Creating exchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_RETRY");
        return new DirectExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_RETRY);
    }

    @Bean
    DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_PARKING() {
        log.info("Creating exchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_PARKING");
        return new DirectExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_PARKING);
    }

    @Bean
    DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_MAIN() {
        log.info("Creating exchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_MAIN");
        return new DirectExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_MAIN);
    }

    @Bean
    DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_RETRY() {
        log.info("Creating exchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_RETRY");
        return new DirectExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_RETRY);
    }

    @Bean
    DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_PARKING() {
        log.info("Creating exchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_PARKING");
        return new DirectExchange(ExchangeName.SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_PARKING);
    }

    //SC START BIDING
    @Bean
    Binding SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN_BIDING(Queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN, DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_MAIN) {
        log.info("Binding queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN to SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_MAIN");
        return BindingBuilder.bind(SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN).to(SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_MAIN).with(QueueName.SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_MAIN);
    }

    @Bean
    Binding SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_RETRY_BIDING(Queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_RETRY, DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_RETRY) {
        log.info("Binding queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_RETRY to SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_RETRY");
        return BindingBuilder.bind(SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_RETRY).to(SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_RETRY).with(QueueName.SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_RETRY);
    }

    @Bean
    Binding SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING_BIDING(Queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING, DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_PARKING) {
        log.info("Binding queue SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING to SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_PARKING");
        return BindingBuilder.bind(SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING).to(SC_RABBITMQ_DIRECT_EXCHANGE_NAME_CATEGORY_RESPONSE_PARKING).with(QueueName.SC_RABBITMQ_QUEUE_NAME_CATEGORY_RESPONSE_PARKING);
    }

    @Bean
    Binding SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN_BIDING(Queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN, DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_MAIN) {
        log.info("Binding queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN to SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_MAIN");
        return BindingBuilder.bind(SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN).to(SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_MAIN).with(QueueName.SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_MAIN);
    }

    @Bean
    Binding SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_RETRY_BIDING(Queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_RETRY, DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_RETRY) {
        log.info("Binding queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_RETRY to SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_RETRY");
        return BindingBuilder.bind(SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_RETRY).to(SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_RETRY).with(QueueName.SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_RETRY);
    }


    @Bean
    Binding SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING_BIDING(Queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING, DirectExchange SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_PARKING) {
        log.info("Binding queue SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING to SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_PARKING");
        return BindingBuilder.bind(SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING).to(SC_RABBITMQ_DIRECT_EXCHANGE_NAME_PRODUCT_RESPONSE_PARKING).with(QueueName.SC_RABBITMQ_QUEUE_NAME_PRODUCT_RESPONSE_PARKING);
    }
}
